
int drawAreaX = 10;
int drawAreaY = 10;
int drawAreaW = 70;
int drawAreaH = 70;

PGraphics pg;

float trans = 0;

PFont myFont;
boolean saveFlag = false;
PrintWriter output;
String message;
LED[] led = new LED[7];

void setup() {
  size(300, 300);
  pg = createGraphics(drawAreaW, drawAreaH, P3D);

  for(int i=0;i<led.length;i++){
    led[i] = new LED();
  } 
  noFill();
  clearGraphics();

  myFont = loadFont("Meiryo-18.vlw");  
  textFont(myFont);
  
  message = "";
}

void draw() {
  background(255);
  
  strokeWeight(3);
   
  stroke(0);
  rectMode(CORNER);
  imageMode(CORNER);
  rect(drawAreaX,drawAreaY,drawAreaW,drawAreaH);
  
  image(pg,drawAreaX,drawAreaY);
  stroke(230,0,0);
//  point(0,0);
  
  pushMatrix();
  
  translate(0,drawAreaH + 30);

  stroke(0,200,0);
  line(0,0,width,0);
  
  pushMatrix();
  translate(10,10);
  translate(drawAreaW/2,drawAreaH/2);

  
  stroke(120);
  rectMode(CENTER);
  imageMode(CENTER);
  rect(0,0,drawAreaW,drawAreaH);
  
  image(pg,0,0);

  popMatrix();  
  stroke(230,100,0);
  //point(0,0);
  
  strokeWeight(2.0);
  rectMode(CENTER);
  for(int i=0;i<7;i++){
    int chx = drawAreaX+int(trans);
    int chy = drawAreaY+5+i*10;

    color c = get(chx,chy+drawAreaH + 30);

    stroke(0);
   
    if( c != color(0)){
      stroke(0,100,100);
      led[i].setPattern(false);
    }else{
      stroke(240,10,10);
      led[i].setPattern(true);
    }
    rect(chx,chy,7,7);
  }
  popMatrix();
  
  trans += 1;
  if(trans > drawAreaW ){
    trans = 0;

    if(saveFlag){
      output = createWriter("LEDpat.h"); 
      for(int i=0;i<7;i++){
        //led[i].printSequence();
        led[i].outputPattern(output,7-i);
        led[i].clearPattern();
      }
      message = "saved.";
      println("saved patterns!");
      output.flush();
      output.close();
      saveFlag = false;
    }
    for(int i=0;i<7;i++){
      led[i].clearPattern();
    }
  }

  drawText();
}

void drawText(){
  fill(0, 102, 153);
  text("Please Draw this area\r\n left button:draw\r\n right button:erase",100,20);
  text("\'s\' key:save\r\n\'c\' key:clear",100,drawAreaH+60);
  fill(160,0,30);
  text(message,100,drawAreaH+130);
  
  noFill();
}

void mouseDragged()
{
  
  if(drawAreaX<mouseX&&drawAreaX+drawAreaW > mouseX && 
   drawAreaY<mouseY && drawAreaY+drawAreaH > mouseY){
      pg.beginDraw();
      if(mouseButton == LEFT){
        pg.strokeWeight(4.5);
        pg.stroke(0);
      }else if(mouseButton == RIGHT){
        pg.strokeWeight(3.5);
        pg.stroke(230);     
      }
      pg.point(mouseX-drawAreaX,mouseY-drawAreaY);     
      pg.endDraw();
  }
}

void keyPressed(){
  if(key == 'c'){
    clearGraphics();
  }else if(key == 'p'){
    led[0].printPattern();
  }else if(key == 's'){
    saveFlag = true;
    message = "update LEDpat.h ...";
  }
}

void clearGraphics()
{
 pg.beginDraw();
 pg.background(230);
 pg.endDraw();
}


class LED{
  boolean nowState = false;
  int time;
  int[] pattern = new int[0];

  void setPattern(boolean state){
    if(nowState==state){
      time++;
    }else{
      nowState = state;
      pattern = append(pattern,time);
      time=0;
    }
  }
  
  void clearPattern(){
    nowState = false;
    pattern = new int[0];
    time = 0;
  }
 
  void printPattern(){
    for(int i=0;i<pattern.length;i++){
      print(pattern[i] + ", ");
    }
    print(" : " + pattern.length);
    println();
  }

  void outputPattern(PrintWriter out,int n){
    out.print("int pat" + n + "[] = {");
    for(int i=0;i<pattern.length;i++){
      out.print(pattern[i] + ", ");
    }
    out.print("-1};");
    out.println();
  }
}


